/*
*********************************************************************************************************
*                                     Embedded Systems Building Blocks
*                                  Complete and Ready-to-Use Modules in C
*
*                                    Asynchronous Serial Communications
*                                           Buffered Serial I/O 
*                                                 (RTOS)
*
*                            (c) Copyright 1999, Jean J. Labrosse, Weston, FL
*                                           All Rights Reserved
*
* Filename   : COMMTEST.C
* Programmer : Jean J. Labrosse
* Translated by : Won-Ho, Sung
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                               ũ
*********************************************************************************************************
*/

#include "c:\\IC96\\Work\\ucos_ii\\includes.h"
#include "CommRtos.h"
/*$PAGE*/
/*
*********************************************************************************************************
*                                                 
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                               Ÿ
*********************************************************************************************************
*/

typedef struct {
    INT16U     RingBufRxCtr;                /* Rx  ۿ                              */
    OS_EVENT  *RingBufRxSem;                /*                                     */
    INT8U     *RingBufRxInPtr;              /*  ͸   Ű                */ 
    INT8U     *RingBufRxOutPtr;             /*  о ͸ Ű                   */ 
    INT8U      RingBufRx[COMM_RX_BUF_SIZE]; /* ſ   念(Rx)                             */ 

    INT16U     RingBufTxCtr;                /* Tx  ۿ                              */
    OS_EVENT  *RingBufTxSem;                /* ۽                                    */
    INT8U     *RingBufTxInPtr;              /*  ͸   Ű                */
    INT8U     *RingBufTxOutPtr;             /*  о ͸ Ű                   */
    INT8U      RingBufTx[COMM_TX_BUF_SIZE]; /* ۽ſ   念(Tx)                             */

} COMM_RING_BUF;

OS_EVENT *P1Sem, *P2Sem, *P3Sem, *P4Sem;

/*
*********************************************************************************************************
*                                              
*********************************************************************************************************
*/

COMM_RING_BUF  ComBuf;
COMM_RING_BUF  *pbuf;

void RxIntHandler(void)
{
    INT8U c;

    c = sbuf;                                              /* Process received character               */

    switch(c)
    {
        case '1':
            OSSemPost(P1Sem);
        break;
        case '2':
            OSSemPost(P2Sem);
        break;
        case '3':
            OSSemPost(P3Sem);
        break;
        case '4':
            OSSemPost(P4Sem);
        break;
    }
}

void TxIntHandler(void)
{
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                          Ÿ ʱȭ
*
*
*         : α׷ Ÿ ʱȭ ϱ   Լ ȣѴ.
*               Ÿ ٸ Լ ȣϱ  ݵ  Լ  ȣؾ Ѵ.
*     : 
*********************************************************************************************************
*/

void  CommInit (void)
{
    INT8U val;

    pbuf                  = &ComBuf;                       /* COMM1    ʱȭ              */
    pbuf->RingBufRxCtr    = 0;
    pbuf->RingBufRxInPtr  = &pbuf->RingBufRx[0];
    pbuf->RingBufRxOutPtr = &pbuf->RingBufRx[0];
    pbuf->RingBufRxSem    = OSSemCreate(0);
    pbuf->RingBufTxCtr    = 0;
    pbuf->RingBufTxInPtr  = &pbuf->RingBufTx[0];
    pbuf->RingBufTxOutPtr = &pbuf->RingBufTx[0];
    pbuf->RingBufTxSem    = OSSemCreate(COMM_TX_BUF_SIZE);
    
    P1Sem = OSSemCreate(0);
    P2Sem = OSSemCreate(0);
    P3Sem = OSSemCreate(0);
    P4Sem = OSSemCreate(0);

    /* Prevent other bits of ioc1 from being altered */ 
    wsr = 15;
    val = ioc1;
    wsr = 0;
    val |= 0x20;
    
    sp_con = 0x09;     /* mode1 & recieve enable */
    ioc1 = val;        /* select TxD */

    /* Baud rate must be written in the order of LSB first at the same address */
    baud_rate = ((unsigned char) BAUD_REG);
    baud_rate = ((unsigned char) (BAUD_REG >> 8));
}

