/*
*********************************************************************************************************
*                                     Embedded Systems Building Blocks
*                                  Complete and Ready-to-Use Modules in C
*
*                                    Asynchronous Serial Communications
*                                           Buffered Serial I/O 
*                                                 (RTOS)
*
*                            (c) Copyright 1999, Jean J. Labrosse, Weston, FL
*                                           All Rights Reserved
*
* Filename   : COMMRTOS.H
* Programmer : Jean J. Labrosse
* Translated by : Won-Ho, Sung
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                              
*********************************************************************************************************
*/

#ifndef  CFG_H

#define  COMM_RX_BUF_SIZE     200                /* Number of characters in Rx ring buffer             */
#define  COMM_TX_BUF_SIZE     200                /* Number of characters in Tx ring buffer             */

#define  BAUD_RATE          57600
#define  BAUD_REG    ((WORD)(SYSTEM_CLOCK/((long)BAUD_RATE*16)-1)+0x8000)

#endif

/*
*********************************************************************************************************
*                                                
*********************************************************************************************************
*/

#ifndef  NUL
#define  NUL                 0x00
#endif

#define  COMM1                  1
#define  COMM2                  2

                                                 /* ڵ                                           */
#define  COMM_NO_ERR            0                /* Լ ȣ  Ǿ                  */
#define  COMM_BAD_CH            1                /* ȿ ä                              */
#define  COMM_RX_EMPTY          2                /*  ۰ . Ͱ                   */
#define  COMM_TX_FULL           3                /* ۽ ۰  á. ͸      */
#define  COMM_TX_EMPTY          4                /* ۽ ۰                                  */
#define  COMM_RX_TIMEOUT        5                /*     ŸӾƿ  ߻             */
#define  COMM_TX_TIMEOUT        6                /*  ۽   ŸӾƿ  ߻             */


#define  COMM_PARITY_NONE       0                /* иƼ                                     */
#define  COMM_PARITY_ODD        1
#define  COMM_PARITY_EVEN       2


#ifdef   COMM_GLOBALS
#define  COMM_EXT
#else
#define  COMM_EXT  extern
#endif
/*$PAGE*/
/*
*********************************************************************************************************
*                                              Լ
*********************************************************************************************************
*/

void TxIntHandler(void);
void RxIntHandler(void);

extern void   CommInit(void);
extern INT8U  CommGetTxChar (INT8U *err);
extern INT8U  CommGetChar (INT16U to, INT8U *err);
extern INT8U  CommPutChar (INT8U c, INT16U to);
extern BOOLEAN  CommIsEmpty (void);
extern BOOLEAN  CommIsFull (void);
