/*
*********************************************************************************************************
*                                    Embedded Systems Building Blocks
*                                 Complete and Ready-to-Use Modules in C
*
*                                         Matrix Keyboard Driver
*
*                            (c) Copyright 1999, Jean J. Labrosse, Weston, FL
*                                           All Rights Reserved
*
* Filename   : KEY.C
* Programmer : Jean J. Labrosse
* Translated by : Won-Ho, Sung
*********************************************************************************************************
*                                                   
*
*    Ű  4  6   Ʈ ϰ ִ. ׷  ڵ 8 x 8 
*      Ʈ Ѵ.   ̹ (column)Է  ϳ   Է
*    ϸ 3 ƮŰ Ѵ.  Ű SHIFT1, SHIFT2 ׸ SHIFT3̴.
*
*     α׷  ݵ ؾ Ѵ(KEY.H ):
*
*    KEY_BUF_SIZE            Ű  ũ
*
*    KEY_MAX_ROWS            Ű ִ (row) 
*    KEY_MAX_COLS            Ű ִ (column) 
*
*    KEY_RPT_DLY             ڵ ݺ ٽ Ǳ  ĵŸ 
*    KEY_RPT_START_DLY       ڵ ݺ Ǳ ĵŸ 
*
*    KEY_SCAN_TASK_DLY       Ű ĵϴ ð 
*    KEY_SCAN_TASK_PRIO      Ű ĳ ½ũ 켱
*    KEY_SCAN_TASK_STK_SIZE  Ű ĳ ½ũ  ũ
*
*    KEY_SHIFT1_MSK          SHIFT1Ű Է   Ʈ شϴ  ϴµ Ǵ ũ
*                                (0x00 SHIFT1Ű  Ѵ)
*    KEY_SHIFT1_OFFSET       SHIFT1Ű     
*
*    KEY_SHIFT2_MSK          SHIFT2Ű Է   Ʈ شϴ  ϴµ Ǵ ũ
*                                (0x00 SHIFT2Ű  Ѵ)
*    KEY_SHIFT2_OFFSET       SHIFT2Ű     
*
*    KEY_SHIFT3_MSK          SHIFT3Ű Է   Ʈ شϴ  ϴµ Ǵ ũ
*                                (0x00 SHIFT3Ű  Ѵ)
*    KEY_SHIFT3_OFFSET       SHIFT3Ű     
*
*
*    KEY_PORT_ROW            Ű Ʈ ࿡ شϴ Ʈ 巹
*    KEY_PORT_COL            Ű Ʈ  شϴ Ʈ 巹
*    KEY_PORT_CW             Ű I/OƮ   巹
*
*    KeyInitPort, KeySelRow() ׸ KeyGetCol() ϵ õ 3 Լ.
*    ̰ ϵ ̽ ̵ 3 Լ ȭ ν   ý
*    ̽ϴ  ϵ ش.
*********************************************************************************************************
*/

/*$PAGE*/
/*
*********************************************************************************************************
*                                              ũ 
*********************************************************************************************************
*/

#include "c:\\IC96\\Work\\ucos_ii\\includes.h"
#include "key.h"

/*
*********************************************************************************************************
*                                                 
*********************************************************************************************************
*/

#define KEY_STATE_UP                 1      /* KeyScan() Ǵ Ű ĳ ½ũ           */
#define KEY_STATE_DEBOUNCE           2
#define KEY_STATE_RPT_START_DLY      3
#define KEY_STATE_RPT_DLY            4

/*
*********************************************************************************************************
*                                                 
*********************************************************************************************************
*/

static  INT8U     KeyBuf[KEY_BUF_SIZE];     /* Ű                                              */
static  INT8U     KeyBufInIx;               /* Ű ۿ    ĵڵ ε      */
static  INT8U     KeyBufOutIx;              /* Ű ۿ    ĵڵ ε        */
static  INT16U    KeyDownTmr;               /* Ű 󸶳   ִ  īƮѴ          */
static  INT8U     KeyNRead;                 /* Űκ  Ű                              */

static  INT8U     KeyRptStartDlyCtr;        /* ڵݺ  ۵Ǳ  ĵŸ                  */
static  INT8U     KeyRptDlyCtr;             /* ڵݺ  ٽ ۵Ǳ  ĵŸ             */

static  INT8U     KeyScanState;             /* Ű ĳ Լ                            */

static  OS_STK    KeyScanTaskStk[KEY_SCAN_TASK_STK_SIZE];  /* Ű ĳ ½ũ               */

static  OS_EVENT *KeySemPtr;                               /* Ű                   */

const char UserKeyMapTbl[] = {
    '1',
    '2',
    '3',
    '4',
    '5',
    '6',
    '7',
    '8',
    '9',
    '*',
    '0',
    '#'
};
/*
*********************************************************************************************************
*                                             Լ 
*********************************************************************************************************
*/

static  void      KeyBufIn(INT8U code);     /* ĵڵ带 Ű ۿ Ѵ                       */
static  INT8U     KeyDecode(void);          /*   Ű ĵڵ带 ´                  */
static  BOOLEAN   KeyIsKeyDown(void);       /* Ű  ִ  ȮѴ                          */
static  void      KeyScanTask(void *data);  /* Ű ĳ ½ũ                                    */

/*$PAGE*/
/*
*********************************************************************************************************
*                                      Ű ڸ Ű ۿ 
*
*      :  Լ Ű ڸ Ű ۿ Ѵ
*  : code  Ű ۿ  ĵڵ
* ϰ   : 
*********************************************************************************************************
*/

static  void  KeyBufIn (INT8U code)
{
    OS_ENTER_CRITICAL();                         /* ũƼ  . ͷƮ ̺ ȴ   */
    if (KeyNRead < KEY_BUF_SIZE) {               /* ۿ ÷ο찡  ȮѴ                */
        KeyNRead++;                              /*  Ű ڸ Ѵ                        */
        KeyBuf[KeyBufInIx++] = code;             /* ĵڵ带 ۿ Ѵ                         */
        if (KeyBufInIx >= KEY_BUF_SIZE) {        /*     ε Ѵ            */
            KeyBufInIx = 0;
        }
        OS_EXIT_CRITICAL();                      /* ũƼ                               */
        OSSemPost(KeySemPtr);                    /* ۿ ĵڵ尡    ñ׳θ*/
    } else {                                     /* ۰  á. ĵڵ带 Ҿ                */
        OS_EXIT_CRITICAL();                      /* ũƼ                               */
    }
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                           Ű ڵ
*
*      :  Լ  Ű ĵڵ带 ϱ  ȣȴ
*  : 
* ϰ   : Ű ĵڵ
*********************************************************************************************************
*/

static  INT8U  KeyDecode (void)
{
    INT8U   col;
    INT8U   row;
    INT8U   offset;
    BOOLEAN done;
    INT8U   col_id;
    INT8U   msk;


    done = FALSE;
    row  = 0;
    while (row < KEY_MAX_ROWS && !done) {             /*  °  Ű ȴ  ˾Ƴ        */
        KeySelRow(row);                               /*  Ѵ                                 */
        if (KeyIsKeyDown()) {                         /* õ  Ű ȴ  ȮѴ         */
            done = TRUE;                              /*  ã⸦ Ѵ                            */
        } else {
            row++;                                    /*   Ѵ                            */
        }
    }
    col    = KeyGetCol();                             /*  д´                                   */
    offset = 0;                                       /* ƹ Ʈ Ű  ʴ  Ѵ    */
    if (col & KEY_SHIFT1_MSK) {                       /* SHIFT1   ִ Ȯ                  */
        offset += KEY_SHIFT1_OFFSET;
    }
    if (col & KEY_SHIFT2_MSK) {                       /* SHIFT2   ִ Ȯ                  */
        offset += KEY_SHIFT2_OFFSET;
    }
    if (col & KEY_SHIFT3_MSK) {                       /* SHIFT3   ִ Ȯ                  */
        offset += KEY_SHIFT3_OFFSET;
    }
    msk    = 0x01;                                    /*  ĵϱ ؼ Ʈ ũ            */
    col_id =    0;                                    /*   ƮѴ (0..7)                     */
    done   = FALSE;
    while (col_id < KEY_MAX_COLS && !done) {          /*   Ѵ                            */
        if (col & msk) {                              /* ̹   ִ  ȮѴ             */
            done  = TRUE;                             /* , i Ű   Ǿ (0..7)  */
        } else {
            col_id++;
            msk <<= 1;
        }
    }
    return (row * KEY_MAX_COLS + offset + col_id);    /* ĵڵ带 Ѵ                           */
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                              Ű  ÷
*
*      :  Լ Ű ۸ Ŭ Ѵ
*  : 
* ϰ   : 
*********************************************************************************************************
*/

void  KeyFlush (void)
{
    while (KeyHit()) {                           /* Ű ۿ ĵڵ尡 ִ  ݺ...         */
        KeyGetKey(0);                            /* ... ۷   ĵڵ带 о´           */
    }
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                             ĵڵ带 Ѵ
*
*      : Ű ̹κ ĵڵ带 о´
*  : 'to'  Ű   KeyGetKey() ٷ ϴ ð Ÿ
*            0  Ű    ٷ  ǹѴ
* ϰ   : != 0xFF    Ű ĵڵ 
*            == 0xFF   'to'   ŸӾƿ  Ű  ʾ Ÿ
*********************************************************************************************************
*/

INT8U  KeyGetKey (INT16U to)
{
    INT8U code;
    INT8U err;


    OSSemPend(KeySemPtr, to, &err);              /* Ű   ٸ                          */
    OS_ENTER_CRITICAL();                         /* ũƼ  Ѵ. ͷƮ ̺ ȴ */
    if (KeyNRead > 0) {                          /* Ű ۿ ĵڵ尡 ִ  ȮѴ        */
        KeyNRead--;                              /*  Ű  ҽŲ                      */
        code = KeyBuf[KeyBufOutIx];              /* ۷  ĵڵ带 о´                    */
        KeyBufOutIx++;
        if (KeyBufOutIx >= KEY_BUF_SIZE) {       /* Ű  ε Ѵ                    */
            KeyBufOutIx = 0;
        }
        OS_EXIT_CRITICAL();                      /* ũƼ  Ѵ                           */
        return (code);                           /*  Ű ĵڵ带 Ѵ                    */
    } else {
        OS_EXIT_CRITICAL();                      /* ũƼ  Ѵ                           */
        return (0xFF);                           /* ۿ ĵڵ尡 . -1 Ѵ              */
    }
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                  Ű 󸶳   ־  ˾Ƴ
*
*      :  Լ Ű  ִ ð Ѵ
*  : 
* ϰ   : Ű  ð(и, milliseconds)
*********************************************************************************************************
*/

INT32U  KeyGetKeyDownTime (void)
{
    INT16U tmr;


    OS_ENTER_CRITICAL();
    tmr = KeyDownTmr;
    OS_EXIT_CRITICAL();
    return (tmr * KEY_SCAN_TASK_DLY);
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                 ۿ ĵڵ尡 Ǿ ִ  ˾Ƴ
*
*      :  Լ Ű  ־  ȮѴ
*  : 
* ϰ   : TRUE   Ű  
*            FALSE  Ű  ʾҴ 
*********************************************************************************************************
*/

BOOLEAN  KeyHit (void)
{
    BOOLEAN hit;


    OS_ENTER_CRITICAL();
    hit = (BOOLEAN)(KeyNRead > 0) ? TRUE : FALSE;
    OS_EXIT_CRITICAL();
    return (hit);
}

/*
*********************************************************************************************************
*                                             Ű ʱȭ
*
*      : Ű ʱȭ Լ. KeyInit() Ű õ  Լ ȣϱ  ݵ ʷ 
*            ȣǾ Ѵ
*  : 
* ϰ   : 
*********************************************************************************************************
*/

void  KeyInit (void)
{
    KeySelRow(KEY_ALL_ROWS);                     /*   Ѵ                                 */
    KeyScanState = KEY_STATE_UP;                 /* Ű ĳ ½ũ ʱ¸ ƮѴ         */
    KeyNRead     = 0;                            /*  Ű  ϴ  ʱȭ              */
    KeyDownTmr   = 0;
    KeyBufInIx   = 0;                            /*  ĵڵ  ó ۵           */
    KeyBufOutIx  = 0;                            /*  ĵڵ  ó ۵           */
    KeySemPtr    = OSSemCreate(0);               /* Ű  ʱȭ                             */
    KeyInitPort();                               /* Ű ̹ Ǵ I/OƮ ʱȭ        */
    OSTaskCreate(KeyScanTask, (void *)0, &KeyScanTaskStk[KEY_SCAN_TASK_STK_SIZE], KEY_SCAN_TASK_PRIO);
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                           SEE IF KEY PRESSED
*
*      :  Լ  Ű  ִ  ˾Ƴ
*  : 
* ϰ   : TRUE   Ű  
*            FALSE  Ű   
* Ʈ     : (1 << KEY_MAX_COLS) - 1   Է иϱ  Ǵ ũ ̴
*            (i.e. mask off the SHIFT keys).
*********************************************************************************************************
*/

static  BOOLEAN  KeyIsKeyDown (void)
{
    if (KeyGetCol() & ((1 << KEY_MAX_COLS) - 1)) {         /* 0̸ Ű   ǹ          */
        OS_ENTER_CRITICAL();
        KeyDownTmr++;                                      /* Űٿ ī͸ Ѵ                 */
        OS_EXIT_CRITICAL();
        return (TRUE);
    } else {
        return (FALSE);
    }
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                          Ű ĳ ½ũ
*
*      :  Լ Ű ĳ ½ũ.  ½ũ 켱  Ҵž ϸ
*            ĳ ֱ KEY_SCAN_TASK_DLY  ȴ
*  : 'data'  ½ũ   ޵Ǵ  ( )
* ϰ   : KeyScanTask() ͵ ʴ´
* Ʈ     : KEY_RPT_START_DLY  Ű  ִ  ڵݺ  Ѵ
*            ϴ ڵݺ  ۵Ǹ Ű  ִ  KEY_RPT_DLY ݺȴ
*             , Ű ĳ 50msec ǰ KEY_RPT_START_DLY 40, KEY_RPT_DLY 2
*            Ǿ ִٸ, ڵݺ Ű   2Ŀ ۵ǰ 100msec Ű ݺ ̴
*
*
*********************************************************************************************************
*/

/*$PAGE*/
static  void  KeyScanTask (void *data)
{
    INT8U code;


    data = data;                                           /* Ϸ  Ѵ (uC/OS-II req.)   */
    for (;;) {
        OSTimeDlyHMSM(0, 0, 0, KEY_SCAN_TASK_DLY);         /* Ű ĳ                      */
        switch (KeyScanState) {
            case KEY_STATE_UP:                             /* Ű  ִ  Ȯ ʿ䰡  */
                 if (KeyIsKeyDown()) {                     /* Ű ȮѴ                        */
                     KeyScanState = KEY_STATE_DEBOUNCE;    /* ٿ Ʈ              */
                     KeyDownTmr   = 0;                     /* Űٿ Ÿ̸Ӹ                      */
                 }
                 break;

            case KEY_STATE_DEBOUNCE:                       /* Ű , ĵڵ带 Ȯ                 */
                 if (KeyIsKeyDown()) {                     /* Ű ȴ°?                           */
                     code              = KeyDecode();      /*  Ű ĵڵ带 ˾Ƴ            */
                     KeyBufIn(code);                       /* ĵڵ带 ۿ                    */
                     KeyRptStartDlyCtr = KEY_RPT_START_DLY;/* ڵݺ  ϱ   */
                     KeyScanState      = KEY_STATE_RPT_START_DLY;
                 } else {
                     KeySelRow(KEY_ALL_ROWS);              /*                              */
                     KeyScanState      = KEY_STATE_UP;     /* Ű   ʴ                    */
                 }
                 break;

            case KEY_STATE_RPT_START_DLY:
                 if (KeyIsKeyDown()) {                     /*  Ű  ִ°?               */
                     if (KeyRptStartDlyCtr > 0) {          /* ڵݺ   ̰ ʿѰ?*/
                         KeyRptStartDlyCtr--;              /* , ڵݺ   ī͸    */
                         if (KeyRptStartDlyCtr == 0) {     /* ڵݺ  ̰ ϷǾ°?...*/
                             code         = KeyDecode();   /* ĵڵ带 ˾Ƴ                      */
                             KeyBufIn(code);               /* ۿ ĵڵ带 Ѵ               */
                             KeyRptDlyCtr = KEY_RPT_DLY;   /*  ݺ    ε        */
                             KeyScanState = KEY_STATE_RPT_DLY;
                         }
                     }
                 } else {
                     KeyScanState = KEY_STATE_DEBOUNCE;    /* Ű   ʴ                    */
                 }
                 break;

            case KEY_STATE_RPT_DLY:
                 if (KeyIsKeyDown()) {                     /*  Ű  ִ°?               */
                     if (KeyRptDlyCtr > 0) {               /* Ű ݺ ٸ ʿ䰡 ִ°?        */
                         KeyRptDlyCtr--;                   /* , ϰ  Űݺ ٸ      */
                         if (KeyRptDlyCtr == 0) {          /* Ű ݺ ΰ                       */
                             code         = KeyDecode();   /* ĵڵ带 ˾Ƴ                      */
                             KeyBufIn(code);               /* ĵڵ带 Ѵ                      */
                             KeyRptDlyCtr = KEY_RPT_DLY;   /* ڵݺ ʿ   εѴ */
                         }
                     }
                 } else {
                     KeyScanState = KEY_STATE_DEBOUNCE;    /* Ű                       */
                 }
                 break;
        }
    }
}

/*$PAGE*/
/*
*********************************************************************************************************
*                                                  б
*
*      :  Լ  Ʈ б ȣȴ
*  : 
* ϰ   :  Ʈ øƮ ̹Ƿ 1   Ʈ شϴ  
*********************************************************************************************************
*/

#ifdef ORIGINAL_DRIVER
INT8U  KeyGetCol (void)
{
    return (~inp(KEY_PORT_COL));                 /* Complement columns (1 Ű  ǹ)        */
}
#else
INT8U  KeyGetCol (void)
{
    INT8U val;
    
    val = ioport1;
    val = ~val;
    val >>= 4;
    val &= 0x07;
    return val;
}
#endif


/*
*********************************************************************************************************
*                                             I/O Ʈ ʱȭ
*********************************************************************************************************
*/

#ifdef ORIGINAL_DRIVER
void  KeyInitPort (void)
{
    outp(KEY_PORT_CW, 0x82);                     /* 82C55ʱȭ : A=, B=Է(), C=()       */
}
#else
void  KeyInitPort (void)
{
}
#endif


/*
*********************************************************************************************************
*                                                  
*
*      :  Լ Ű  ϱ  ȣȴ
*  : row    (0..7) Ǵ KEY_ALL_ROWS
* ϰ   : 
* Note     :   0 ν õ
*********************************************************************************************************
*/

#ifdef ORIGINAL_DRIVER
void  KeySelRow (INT8U row)
{
    if (row == KEY_ALL_ROWS) {
        outp(KEY_PORT_ROW, 0x00);                /*   0                              */
    } else {
        outp(KEY_PORT_ROW, ~(1 << row));         /* ϴ ุ 0                            */
    }
}
#else
void  KeySelRow (INT8U row)
{
    if (row == KEY_ALL_ROWS) {
        ioport1 = 0xf0;                         /*   0                              */
    } else {
        row = ~(1 << row);
        row |= 0xf0;
        ioport1 = row;                          /* ϴ ุ 0                            */
    }
}
#endif
