#include "..\\includes.h"
#include "..\\drivers\\lcd.h"
#include "..\\drivers\\CommRtos.h"

/********************************************************************************************/
/*                                                                                  */
/********************************************************************************************/
#define  TASK_STK_SIZE       100      /*  ½ũ  ũ (16Ʈ )                */
#define  N_TASKS               9      /*  ڵ ½ũ Ǵ                    */

#define  KEY_ESC             0x1b

#define  CHAR_TASK_DELAY       1
#define  BAR_TASK_DELAY1       1
#define  BAR_TASK_DELAY2       1
/********************************************************************************************/
/*                                                                              */
/********************************************************************************************/
OS_STK   TaskStartStk[TASK_STK_SIZE];         /* TaskStart()Լ ÿ                 */
OS_STK   barTaskStk[TASK_STK_SIZE];           /* barTask()Լ ÿ                   */
OS_STK   commTaskStk[TASK_STK_SIZE];          /* barTask()Լ ÿ                   */
OS_STK   TaskStk[N_TASKS][TASK_STK_SIZE];     /* charTask()Լ ÿ                  */
BYTE     TaskData[N_TASKS];                   /* charTask() ޵Ǵ ĶͿ 迭      */


/********************************************************************************************/
/*                                          Լ                                        */
/********************************************************************************************/
void     TaskStart(void *data);
void     charTask(void *data);
void     barTask(void *data);
void     commTask(void *data);

/********************************************************************************************/
/*                                       ܺ Լ                                      */
/********************************************************************************************/
extern void TimeTickInit(void);

void main (void)
{
    OSInit();                                                   /* uC/OS-II ʱȭѴ    */
    /*  ½ũ  */
    OSTaskCreate(TaskStart, (void *)0, (void *)&TaskStartStk[TASK_STK_SIZE - 1], 0);
    OSStart();                                                  /* uC/OS-II ⵿            */
}

void TaskStart(void *pdat)
{
    BYTE i, ret;
    BYTE sData;
    char * sPtr;
    char dispBuf[30];

    disable();                                                  /* ͷƮ Ȱȭ        */  
    TimeTickInit();                                             /* Ÿ ƽ Ÿ̸ ʱȭ  */
    enable();                                                   /* ͷƮ Ȱȭ          */

    CommInit();
    DispInit(2,16);                     /* LCD ̹ 2*16  ʱȭѴ            */
    DispHorBarInit();                   /* LCD CG α׷Ѵ                        */
    DispStr(0,0," System init..");
    DispStr(1,0," Please wait..");
    
    OSStatInit();
    DispClrScr();
    
    ret = 0;

    for(i=0;i<N_TASKS;i++)              /* N_TASKSŭ  ½ũ Ѵ               */
    {   
        TaskData[i] = i;                /*  ½ũ ó ǥ ͸ Ѱش    */
        ret += OSTaskCreate(charTask, (void *)&TaskData[i], (void *)&TaskStk[i][TASK_STK_SIZE - 1], i+1);
    }
    ret += OSTaskCreate(barTask, (void *)0, (void *)&barTaskStk[TASK_STK_SIZE - 1], i+2);
    ret += OSTaskCreate(commTask, (void *)0, (void *)&commTaskStk[TASK_STK_SIZE - 1], i+3);

    if(ret)
    {
        /* ret     ½ũ   ߻  */
        DispStr(1, 0,(char *)"Prio Err");
        OSTimeDlyHMSM(0,0,5,0);
    }

    i = 0;
    /* ½ũ ӹ ϷǷ ѷ ݺѴ */
    while(1)
    {
        /* 1  CPU  ȯ ȸ ǥ */
        OSTimeDlyHMSM(0,0,1,0); /* 1  */
        sprintf(dispBuf,"%02d%%,%04d", OSCPUUsage, OSCtxSwCtr);
        DispStr(1,0,dispBuf);
        OS_ENTER_CRITICAL();
        OSCtxSwCtr = 0;
        OS_EXIT_CRITICAL();
        sprintf(dispBuf, "This is first example : %03d\r", i++);
        sPtr = dispBuf;
        while(*sPtr)
        {
            ret = CommPutChar(*sPtr++, 0);
        }
    }
}

void charTask(void *pdat)
{
    BYTE val, cnt;

    val = *(BYTE *)pdat;
    val %= 10;
    val += '0';

    for (;;)
    {
        /* timer1  ڸ ǥ  ġ о´ */
        cnt = (BYTE)(timer1%16);
        
        /* Ÿ̸ӿ   LCDǥ ȯؼ 1ڸ ÷Ѵ */
        DispChar(0, cnt, val); 
        
        /* 1 Time tick  ·  */
        /* ̶ ٸ   ½ũ ࿡  */
        OSTimeDly(CHAR_TASK_DELAY);
    }
}

void barTask(void *data)
{
    BYTE i;
    char str[5];

    data = data;

    i = 0;

    for (;;) {
        for(i=0;i<=30;i++)
        {
            /* 0 30  ̿ؼ ٱ׷ Ѵ */
            DispHorBar(1,8,i);
            sprintf(str,"%02d", i);
            DispStr(1,14,str);
            OSTimeDly(BAR_TASK_DELAY1);
        }
        OSTimeDly(BAR_TASK_DELAY2);
        for(i=29;i>0;i--)
        {
            /* 29 0  ̿ؼ ٱ׷ Ѵ */
            DispHorBar(1,8,i);
            sprintf(str,"%02d", i);
            DispStr(1,14,str);
            OSTimeDly(BAR_TASK_DELAY1);
        }
        OSTimeDly(BAR_TASK_DELAY2);
    }
}

void commTask(void *data)
{
    INT16U cnt;
    INT8U sData, err;
    char dispBuf[30];
    
    cnt = 0;
    for(;;){
        sData = CommGetChar(0, &err);
        if(sData==KEY_ESC) asm rst;
        sprintf(dispBuf,"%05u", cnt++);
        DispStr(1,3,dispBuf);
    }
}
